from collections.abc import Iterator
from concurrent.futures import Future
from tlc.core.url import Scheme as Scheme, Url as Url
from tlc.core.url_adapter import UrlAdapterAsyncFromSync as UrlAdapterAsyncFromSync, UrlAdapterDirEntry as UrlAdapterDirEntry
from tlc.core.url_adapter_registry import UrlAdapterRegistry as UrlAdapterRegistry

class HttpUrlAdapter(UrlAdapterAsyncFromSync):
    """
    An adapter for resolving reads/writes to URLs starting with `http://` or `https://`
    """
    def schemes(self) -> list[Scheme]: ...
    def read_string_content_from_url(self, url: Url) -> str: ...
    def read_binary_content_from_url(self, url: Url) -> bytes: ...
    def delete_url(self, url: Url) -> None: ...
    def make_dirs(self, url: Url, exist_ok: bool = False) -> None: ...
    def get_file_size(self, url: Url) -> int: ...
    def list_dir(self, url: Url) -> Iterator[UrlAdapterDirEntry]: ...
    def exists(self, url: Url) -> bool: ...
    def is_dir(self, url: Url) -> bool: ...
    def is_writable(self, url: Url) -> bool: ...
    def stat(self, url: Url) -> UrlAdapterDirEntry:
        """Http URLs don't support file status operations.

        :param url: The URL to get status for
        :raises NotImplementedError: Always, as Http URLs don't support stat
        """
    def stat_async(self, url: Url) -> Future: ...
    def touch(self, url: Url) -> None:
        """Http URLs don't support file modification operations.

        :param url: The URL to touch
        :raises NotImplementedError: Always, as API URLs don't support touch
        """
